#!/bin/sh

#This file is based on misc/RPM/exmh.spec

WISHBIN=${PREFIX_tk}/bin/wish
EXPECTBIN=${PREFIX_expect}/bin/expect


#Make installdirs.
mkdir -p ${PREFIX}
mkdir -p ${PREFIX}/bin
mkdir -p ${PREFIX}/lib
mkdir -p ${PREFIX}/man/man1


cat >exmh.MPKG_CONFIG <<EOF
#!${WISHBIN}
#CONFIGURATION
set wish ${WISHBIN}
set exmh(version) {${EXMH_VERSION}}
set exmh(name) exmh
set exmh(maintainer) welch@acm.org
set mh_path ${PREFIX_mh}/bin/mh
set exmh(slocal) /usr/lib/mh/slocal
set mime(dir) ${PREFIX_metamail}
set mailcap_default /etc/mailcap
set exmh(expect) ${PREFIX_expect}/bin/expect
set exmh(expectk) ${PREFIX_expect}/bin/expectk
#Change this
set faces(dir) /usr/local/faces/faces
set faces(set,user) {local users usenix misc}
set faces(set,unknown) {domains unknown}
set faces(set,news) news
set faces(defaultDomain) e.kth.se
set faces(suffix) {xpm gif xbm}
set pgp(pgp,path) ${PREFIX_pgp}/usr/bin
set pgp(pgp5,path) ${PREFIX_pgp}/usr/bin
set pgp(gpg,path) ${PREFIX_pgp}/usr/bin
set glimpse(path) ${PREFIX_glimpse}/bin
set sound(cmd) {${PREFIX_sox}/bin/play -v 38}
set exmh(library) ${PREFIX}/lib
set install(dir,bin) ${PREFIX}/bin
set install(dir,man) ${PREFIX}/man/man1
set install(dir,lib) ${PREFIX}/lib
#END CONFIGURATION
EOF


#Defaults
for i in *.MASTER; do
    foo=`echo $i | sed -e "s/.MASTER//"`;
    cp $i $foo;
done

#Configure exmh-async
( echo \#\!${WISHBIN}; cat exmh-async.MASTER ) > exmh-async

#Configure exmh-bg
cat exmh.MPKG_CONFIG exmh-bg.MASTER >exmh-bg

#Configure exmh
cat exmh.MPKG_CONFIG exmh.MASTER >exmh

#Configure ftp.expect
( echo \#\!${EXPECTBIN}; cat ftp.expect.MASTER ) > ftp.expect


#Probably useful
echo 'auto_mkindex ./lib *.tcl' | tclsh
