--- src/unix-gcc.mak.old	Tue Sep 18 08:01:33 2001
+++ src/unix-gcc.mak	Tue Oct  2 15:39:42 2001
@@ -56,16 +56,16 @@
 INSTALL_PROGRAM = $(INSTALL) -m 755
 INSTALL_DATA = $(INSTALL) -m 644
 
-prefix = /usr/local
+prefix = @PREFIX@
 exec_prefix = $(prefix)
 bindir = $(exec_prefix)/bin
 scriptdir = $(bindir)
 libdir = $(exec_prefix)/lib
 mandir = $(prefix)/man
 man1ext = 1
-datadir = $(prefix)/share
-gsdir = $(datadir)/ghostscript
-gsdatadir = $(gsdir)/$(GS_DOT_VERSION)
+datadir = $(prefix)
+gsdir = $(datadir)
+gsdatadir = $(gsdir)
 
 docdir=$(gsdatadir)/doc
 exdir=$(gsdatadir)/examples
@@ -100,8 +100,10 @@
 #	makes private (static) procedures and variables public,
 #	  so they are visible to the debugger and profiler.
 #	  No execution time or space penalty.
+# -DA4
+#	makes A4 the default paper size
 
-GENOPT=
+GENOPT=-DA4
 
 # Choose capability options.
 
@@ -137,7 +139,7 @@
 # You may need to change this if the IJG library version changes.
 # See jpeg.mak for more information.
 
-JSRCDIR=jpeg
+JSRCDIR=jpeg-6b
 JVERSION=6
 
 # Choose whether to use a shared version of the IJG JPEG library (-ljpeg).
@@ -157,26 +159,26 @@
 # You may need to change this if the libpng version changes.
 # See libpng.mak for more information.
 
-PSRCDIR=libpng
-PVERSION=10012
+PSRCDIR=@PNGDIR@/include
+PVERSION=10008
 
 # Choose whether to use a shared version of the PNG library, and if so,
 # what its name is.
 # See gs.mak and Make.htm for more information.
 
-SHARE_LIBPNG=0
+SHARE_LIBPNG=1
 LIBPNG_NAME=png
 
 # Define the directory where the zlib sources are stored.
 # See zlib.mak for more information.
 
-ZSRCDIR=zlib
+ZSRCDIR=@ZLIBDIR@/include
 
 # Choose whether to use a shared version of the zlib library, and if so,
 # what its name is (usually libz, but sometimes libgz).
 # See gs.mak and Make.htm for more information.
 
-SHARE_ZLIB=0
+SHARE_ZLIB=1
 #ZLIB_NAME=gz
 ZLIB_NAME=z
 
@@ -229,7 +231,7 @@
 # We don't include -ansi, because this gets in the way of the platform-
 #   specific stuff that <math.h> typically needs; nevertheless, we expect
 #   gcc to accept ANSI-style function prototypes and function definitions.
-XCFLAGS=
+XCFLAGS=@CFLAGS@
 
 CFLAGS=$(CFLAGS_STANDARD) $(GCFLAGS) $(XCFLAGS)
 
@@ -240,7 +242,7 @@
 #	-R /usr/local/xxx/lib:/usr/local/lib
 # giving the full path names of the shared library directories.
 # XLDFLAGS can be set from the command line.
-XLDFLAGS=
+XLDFLAGS=@LDFLAGS@
 
 LDFLAGS=$(XLDFLAGS) -fno-common
 
@@ -260,10 +262,10 @@
 # All reasonable platforms require -lm, but Rhapsody and perhaps one or
 # two others fold libm into libc and don't require any additional library.
 
-#STDLIBS=-lpthread -lm
+STDLIBS=-lpthread -lm
 
 # Since the default build is for nosync, don't include pthread lib
-STDLIBS=-lm
+#STDLIBS=-lm
 
 # Define the include switch(es) for the X11 header files.
 # This can be null if handled in some other way (e.g., the files are
@@ -273,7 +275,7 @@
 # Note that x_.h expects to find the header files in $(XINCLUDE)/X11,
 # not in $(XINCLUDE).
 
-XINCLUDE=-I/usr/X11R6/include
+XINCLUDE=-I@X11DIR@/include
 
 # Define the directory/ies and library names for the X11 library files.
 # XLIBDIRS is for ld and should include -L; XLIBDIR is for LD_RUN_PATH
@@ -288,9 +290,9 @@
 #XLIBS=Xt SM ICE Xext X11
 
 #XLIBDIRS=-L/usr/local/X/lib
-XLIBDIRS=-L/usr/X11R6/lib
+XLIBDIRS=-L@X11DIR@/lib
 XLIBDIR=
-XLIBS=Xt Xext X11
+XLIBS=Xt SM ICE Xext X11
 
 # Define whether this platform has floating point hardware:
 #	FPU_TYPE=2 means floating point is faster than fixed point.
@@ -301,17 +303,17 @@
 #	FPU_TYPE=-1 means that floating point is always much slower than
 # fixed point.
 
-FPU_TYPE=1
+FPU_TYPE=2
 
 # Define the .dev module that implements thread and synchronization
 # primitives for this platform.
 
 # If POSIX sync primitives are used, also change the STDLIBS to include
 # the pthread library.
-#SYNC=posync
+SYNC=posync
 
 # Default is No sync primitives since some platforms don't have it (HP-UX)
-SYNC=nosync
+#SYNC=nosync
 
 # ------ Devices and features ------ #
 
@@ -332,7 +334,7 @@
 # Choose whether to store band lists on files or in memory.
 # The choices are 'file' or 'memory'.
 
-BAND_LIST_STORAGE=file
+BAND_LIST_STORAGE=memory
 
 # Choose which compression method to use when storing band lists in memory.
 # The choices are 'lzw' or 'zlib'.  lzw is not recommended, because the
