Index: print-rx.c
===================================================================
RCS file: /tcpdump/master/tcpdump/print-rx.c,v
retrieving revision 1.20
retrieving revision 1.25
diff -u -w -r1.20 -r1.25
--- print-rx.c	2001/01/10 08:12:01	1.20
+++ print-rx.c	2001/07/09 09:24:09	1.25
@@ -13,7 +13,7 @@
 
 #ifndef lint
 static const char rcsid[] =
-    "@(#) $Header: /afs/e.kth.se/src/SourceRepository//mpkg/programs/tcpdump/3.6.2/patches/patch-print-rx.c,v 1.1 2001/07/21 12:03:09 mattiasa Exp $";
+    "@(#) $Header: /afs/e.kth.se/src/SourceRepository//mpkg/programs/tcpdump/3.6.2/patches/patch-print-rx.c,v 1.1 2001/07/21 12:03:09 mattiasa Exp $";
 #endif
 
 #ifdef HAVE_CONFIG_H
@@ -35,9 +35,6 @@
 #include "addrtoname.h"
 #include "extract.h"
 
-#undef NOERROR					/* Solaris sucks */
-#include <arpa/nameser.h>
-
 #include "rx.h"
 
 #include "ip.h"
@@ -635,14 +632,16 @@
 			printf(" fid %d/%d/%d", (int) n1, (int) n2, (int) n3); \
 		}
 
-#define STROUT(MAX) { int i; \
+#define STROUT(MAX) { unsigned int i; \
 			TCHECK2(bp[0], sizeof(int32_t)); \
-			i = (int) EXTRACT_32BITS(bp); \
+			i = EXTRACT_32BITS(bp); \
+			if (i > (MAX)) \
+				goto trunc; \
 			bp += sizeof(int32_t); \
-			TCHECK2(bp[0], i); \
-			strncpy(s, (char *) bp, min(MAX, i)); \
-			s[i] = '\0'; \
-			printf(" \"%s\"", s); \
+			printf(" \""); \
+			if (fn_printn(bp, i, snapend)) \
+				goto trunc; \
+			printf("\""); \
 			bp += ((i + sizeof(int32_t) - 1) / sizeof(int32_t)) * sizeof(int32_t); \
 		}
 
@@ -719,15 +718,20 @@
  */
 
 #define VECOUT(MAX) { char *sp; \
+			char s[AFSNAMEMAX]; \
 			int k; \
-			TCHECK2(bp[0], MAX * sizeof(int32_t)); \
+			if ((MAX) + 1 > sizeof(s)) \
+				goto trunc; \
+			TCHECK2(bp[0], (MAX) * sizeof(int32_t)); \
 			sp = s; \
-			for (k = 0; k < MAX; k++) { \
+			for (k = 0; k < (MAX); k++) { \
 				*sp++ = (char) EXTRACT_32BITS(bp); \
 				bp += sizeof(int32_t); \
 			} \
-			s[MAX] = '\0'; \
-			printf(" \"%s\"", s); \
+			s[(MAX)] = '\0'; \
+			printf(" \""); \
+			fn_print(s, NULL); \
+			printf("\""); \
 		}
 
 static void
@@ -808,7 +812,6 @@
 {
 	int fs_op;
 	unsigned long i;
-	char s[AFSNAMEMAX];
 
 	if (length <= sizeof(struct rx_header))
 		return;
@@ -959,7 +962,6 @@
 fs_reply_print(register const u_char *bp, int length, int32_t opcode)
 {
 	unsigned long i;
-	char s[AFSNAMEMAX];
 	struct rx_header *rxh;
 
 	if (length <= sizeof(struct rx_header))
@@ -1087,7 +1089,9 @@
 		if (sscanf((char *) s, "%s %d\n%n", user, &acl, &n) != 2)
 			goto finish;
 		s += n;
-		printf(" +{%s ", user);
+		printf(" +{");
+		fn_print(user, NULL);
+		printf(" ");
 		ACLOUT(acl);
 		printf("}");
 		if (s > end)
@@ -1098,7 +1102,9 @@
 		if (sscanf((char *) s, "%s %d\n%n", user, &acl, &n) != 2)
 			goto finish;
 		s += n;
-		printf(" -{%s ", user);
+		printf(" -{");
+		fn_print(user, NULL);
+		printf(" ");
 		ACLOUT(acl);
 		printf("}");
 		if (s > end)
@@ -1251,7 +1257,6 @@
 prot_print(register const u_char *bp, int length)
 {
 	unsigned long i;
-	char s[AFSNAMEMAX];
 	int pt_op;
 
 	if (length <= sizeof(struct rx_header))
@@ -1395,7 +1400,6 @@
 {
 	struct rx_header *rxh;
 	unsigned long i;
-	char s[AFSNAMEMAX];
 
 	if (length < sizeof(struct rx_header))
 		return;
@@ -1508,7 +1512,6 @@
 {
 	int vldb_op;
 	unsigned long i;
-	char s[AFSNAMEMAX];
 
 	if (length <= sizeof(struct rx_header))
 		return;
@@ -1602,7 +1605,6 @@
 {
 	struct rx_header *rxh;
 	unsigned long i;
-	char s[AFSNAMEMAX];
 
 	if (length < sizeof(struct rx_header))
 		return;
@@ -1789,7 +1791,6 @@
 kauth_print(register const u_char *bp, int length)
 {
 	int kauth_op;
-	char s[AFSNAMEMAX];
 
 	if (length <= sizeof(struct rx_header))
 		return;
@@ -2016,7 +2017,6 @@
 bos_print(register const u_char *bp, int length)
 {
 	int bos_op;
-	char s[BOSNAMEMAX];
 
 	if (length <= sizeof(struct rx_header))
 		return;
