--- score.C	Thu Apr  4 04:48:55 1996
+++ score.C.mine	Wed Feb 21 18:08:31 2001
@@ -34,6 +34,9 @@
 #include "score.h"
 #include "file.h"
 
+#define SD_LEN 1024
+#define SD_SUF "/.xkobo-scores"
+
 int  _scorefile::highscore       = 0;
 char _scorefile::save_path[1024];
 char _scorefile::login_name[64];
@@ -53,6 +56,29 @@
 
 void _scorefile::init(int *highscorep, int *stagep)
 {
+    char scoredir[SD_LEN];
+
+    char *scoredirtmp = getenv("XKOBOSCOREDIR"); 
+    if (scoredirtmp == NULL) {
+	scoredirtmp = getenv("HOME");
+	if (scoredirtmp == NULL) {
+	    fprintf(stderr, "No XKOBOSCOREDIR or HOME set!\n");
+	    exit(1);
+	} else if (strlen(scoredirtmp) >= 
+		   (SD_LEN - strlen(SD_SUF))) {
+	    fprintf(stderr, "Environment variable HOME too long!\n");
+	    exit(1);
+	}
+	strcpy(scoredir, scoredirtmp);
+	strcat(scoredir, SD_SUF);
+    } else {
+	if (strlen(scoredirtmp) >= SD_LEN) {
+	    fprintf(stderr, "Environment variable XKOBOSCOREDIR too long!\n");
+	    exit(1);
+	}
+	strcpy(scoredir, scoredirtmp);
+    }
+
     s_table tbl;
     tbl.score = 0;
     tbl.scene = 0;
@@ -66,7 +92,8 @@
     else {
         strcpy(login_name, pw->pw_name);
     }
-    sprintf(save_path, "%s/%d", XKOBO_SCORE_DIR, getuid());
+    mkdir(scoredir, (mode_t)0755);
+    sprintf(save_path, "%s/%d", scoredir, getuid());
     if ((i=load_block(save_path, &tbl, sizeof(tbl))) == -1){
         fprintf(stderr, "xkobo : (warning) can't read score-file\n");
     }
@@ -100,6 +127,29 @@
 
 void _scorefile::show_high_scores(int to_stdout)
 {
+    char scoredir[SD_LEN];
+
+    char *scoredirtmp = getenv("XKOBOSCOREDIR"); 
+    if (scoredirtmp == NULL) {
+	scoredirtmp = getenv("HOME");
+	if (scoredirtmp == NULL) {
+	    fprintf(stderr, "No XKOBOSCOREDIR or HOME set!\n");
+	    exit(1);
+	} else if (strlen(scoredirtmp) >= 
+		   (SD_LEN - strlen(SD_SUF))) {
+	    fprintf(stderr, "Environment variable HOME too long!\n");
+	    exit(1);
+	}
+	strcpy(scoredir, scoredirtmp);
+	strcat(scoredir, SD_SUF);
+    } else {
+	if (strlen(scoredirtmp) >= SD_LEN) {
+	    fprintf(stderr, "Environment variable XKOBOSCOREDIR too long!\n");
+	    exit(1);
+	}
+	strcpy(scoredir, scoredirtmp);
+    }
+
     s_table tbl[SCORE_SAVE_MAX];
     char    path[1024];
     int i, j;
@@ -112,11 +162,11 @@
     struct dirent *direntp;
     DIR           *dp;
     struct stat st_buffer;
-    dp = opendir(XKOBO_SCORE_DIR);
+    dp = opendir(scoredir);
     if (dp == NULL) return;
     i = 0;
     while ((direntp = readdir(dp)) != NULL){
-        sprintf(path, "%s/%s", XKOBO_SCORE_DIR, direntp->d_name);
+        sprintf(path, "%s/%s", scoredir, direntp->d_name);
         if (stat(path, &st_buffer)) continue;
         if (!S_ISREG(st_buffer.st_mode)) continue;
         if (load_block(path, &tbl[i], sizeof(s_table)) <= 0) continue;
